module XML where
import PrettierPrinter

data XML = Elt String [Att] [XML]
         | Txt String

data Att = Att String String

showXML x = folddoc (<>) (showXMLs x)

showXMLs (Elt n a []) = [ text "<" <> showTag n a <> text "/>" ]
showXMLs (Elt n a c) = [ text "<" <> showTag n a <> text ">" <>
                         showFill showXMLs c <>
                         text "</" <> text n <> text ">" ]
showXMLs (Txt s) = map text (words s)

showAtts (Att n v) = [ text n <> text "=" <> text (quoted v) ]

quoted s = "\"" ++ s ++ "\""

showTag n a = text n <> showFill showAtts a

showFill f [] = nil
showFill f xs = bracket "" (fill (concat (map f xs))) ""

xml = Elt "p" [ Att "color" "red",
                Att "font" "Times",
                Att "size" "10"
              ] [ Txt "Here is some",
                  Elt "em" [] [ Txt "emphasised" ],
                  Txt "text.",
                  Txt "Here is a",
                  Elt "a" [ Att "href" "http://www.eg.com/" ]
                          [ Txt "link" ],
                  Txt "elsewhere."
                ]

testXML w = putStrLn (pretty w (showXML xml))
