// PanISlider.h: interface for the CPanISlider class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANISLIDER_H__D70EB926_E625_4954_84CE_483C4B511D01__INCLUDED_)
#define AFX_PANISLIDER_H__D70EB926_E625_4954_84CE_483C4B511D01__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Slider.h"
#include "ViewInvalidator.h"
#include "PanDisp.h"

class CPanISlider : public CSlider  
{
public:

    CPanISlider ( HWND          hWndParent
                , LPCTSTR       label
                , int           min
                , int           max
                , IntUpdater*   pUpd
                , void*         pParam
                , CInvalidator* pInvalid
        );
	virtual ~CPanISlider();

    BEGIN_MSG_MAP(CPanISlider)
        MESSAGE_HANDLER(WM_HSCROLL, OnHScroll)
        COMMAND_CODE_HANDLER(EN_CHANGE, OnChange)
        CHAIN_MSG_MAP(CSlider)
    END_MSG_MAP()

    LRESULT OnHScroll(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

private:
    int           m_min, m_max;
    int           m_value;
    IntUpdater*   m_updateValue;
    void*         m_pParam;
    CInvalidator* m_iProc;
    bool          m_inFlux;


};

#endif // !defined(AFX_PANISLIDER_H__D70EB926_E625_4954_84CE_483C4B511D01__INCLUDED_)
