// StatusBar.cpp: implementation of the CStatusBar class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "StatusBar.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStatusBar::CStatusBar()
 : m_hWndStatusBar(NULL)
{

}

CStatusBar::~CStatusBar()
{

}

CStatusBar::CStatusBar(HWND hWndStatus, int cols)
 : m_hWndStatusBar(hWndStatus), m_noColumns(cols)
{
    
}


//////////////////////////////////////////////////////////////////////
// Methods
//////////////////////////////////////////////////////////////////////

void
CStatusBar::ResizeStatusBar()
{
    RECT rc;
    int statusHeight, nWidth, step, i;
    int*  statusWidths;

    statusWidths = new int[m_noColumns];

    ::GetClientRect(m_hWndStatusBar,&rc);
	statusHeight = rc.bottom - rc.top;

	nWidth = (rc.right - 20) / m_noColumns;
	step   = nWidth;
	
	for (i = 0; i < m_noColumns; i++ ) {
		statusWidths[i] = (i+1)*step;
	}

	SendMessage (m_hWndStatusBar, SB_SETPARTS, m_noColumns, (LPARAM)statusWidths);

    delete statusWidths;
}

void
CStatusBar::SetColumns(int i)
{
    m_noColumns = i;
    ResizeStatusBar();
}

int
CStatusBar::GetColumns()
{
    return m_noColumns;
}

void
CStatusBar::SetColumnText(int partNumber, LPCTSTR szText)
{
    ::SendMessage(m_hWndStatusBar,
                  SB_SETTEXT,
                  partNumber,
                  (LPARAM)szText);   
}