// If compiling with gcc, we don't have MIDL generated .h
// files at our disposal (e.g., for ocidl.h), so we'll have to
// improvise and type out the protos manually.

#define COBJMACROS
// This comes from the HDirect library.
#include "comPrim.h"

const IID IID_IPicture = 
  {0x7BF80980L, 0xBF32, 0x101A, {0x8B, 0xBB, 0x00, 0xAA, 0x00, 0x30, 0x0C, 0xAB}};
typedef IStream* LPSTREAM;

extern
HRESULT
STDCALL
CoCreateGuid(
  GUID  *pguid  //Pointer to the GUID on return
);

extern
HRESULT
STDCALL
CLSIDFromProgID
 ( LPCOLESTR lpszProgID,  //Pointer to the ProgID
   LPCLSID pclsid         //Pointer to the CLSID
 );


extern
HRESULT
STDCALL
OleLoadPicture
 ( IStream * pStream
 , LONG lSize
 , BOOL fRunmode
 , REFIID riid
 , VOID** ppvObj
 );

extern
HRESULT
STDCALL
CreateStreamOnHGlobal
  ( HGLOBAL hGlobal
  , BOOL fDeleteOnRelease
  , LPSTREAM *ppstm
  );

typedef UINT OLE_HANDLE;
typedef LONG OLE_XPOS_HIMETRIC;
typedef LONG OLE_YPOS_HIMETRIC;
typedef LONG OLE_XSIZE_HIMETRIC;
typedef LONG OLE_YSIZE_HIMETRIC;

typedef struct IPicture IPicture;

typedef struct IPictureVtbl
  {
        HRESULT (STDCALL *QueryInterface )
	            ( IPicture* This
		    , REFIID riid
		    , void** ppvObject
		    );
        
        ULONG (STDCALL *AddRef )
	            ( IPicture* This);
        
        ULONG (STDCALL* Release )
	            ( IPicture* This);
        
        HRESULT (STDCALL* get_Handle )
	            ( IPicture* This
		    , OLE_HANDLE* pHandle
		    );
        
        HRESULT ( STDCALL* get_hPal )
	            ( IPicture* This
		    , OLE_HANDLE* phPal
		    );
        
        HRESULT ( STDCALL* get_Type )
	            ( IPicture* This
		    , SHORT* pType
		    );
        
        HRESULT ( STDCALL* get_Width )
	            ( IPicture* This
		    , OLE_XSIZE_HIMETRIC* pWidth
		    );
        
        HRESULT ( STDCALL* get_Height )
	            ( IPicture* This
		    , OLE_YSIZE_HIMETRIC* pHeight
		    );
        
        HRESULT ( STDCALL* Render )
	            ( IPicture* This
		    , HDC hDC
		    , LONG x
		    , LONG y
		    , LONG cx
		    , LONG cy
		    , OLE_XPOS_HIMETRIC xSrc
		    , OLE_YPOS_HIMETRIC ySrc
		    , OLE_XSIZE_HIMETRIC cxSrc
		    , OLE_YSIZE_HIMETRIC cySrc
		    , const LPRECT pRcWBounds
		    );
        
        HRESULT ( STDCALL* set_hPal )
	            ( IPicture* This
		    , OLE_HANDLE hPal
		    );
        
        HRESULT ( STDCALL* get_CurDC )
	            ( IPicture* This
		    , HDC* phDC
		    );
        
        HRESULT ( STDCALL* SelectPicture )
	            ( IPicture* This
		    , HDC hDCIn
		    , HDC* phDCOut
		    , OLE_HANDLE* phBmpOut
		    );
        
        HRESULT ( STDCALL* get_KeepOriginalFormat )
	            ( IPicture* This
		    , BOOL* pKeep
		    );
        
        HRESULT ( STDCALL* put_KeepOriginalFormat )
	            ( IPicture* This
		    , BOOL keep
		    );
        
        HRESULT ( STDCALL* PictureChanged )
	            ( IPicture* This);
        
        HRESULT ( STDCALL* SaveAsFile )
	            ( IPicture* This
		    , LPSTREAM pStream
		    , BOOL fSaveMemCopy
		    ,LONG* pCbSize
		    );
        
        HRESULT ( STDCALL* get_Attributes )
	            ( IPicture* This
		    , DWORD* pDwAttr
		    );
        
    } IPictureVtbl;

struct IPicture { struct IPictureVtbl* lpVtbl; };

#define IPicture_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IPicture_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IPicture_Release(This)	\
    (This)->lpVtbl -> Release(This)

#define IPicture_get_Handle(This,pHandle)	\
    (This)->lpVtbl -> get_Handle(This,pHandle)

#define IPicture_get_hPal(This,phPal)	\
    (This)->lpVtbl -> get_hPal(This,phPal)

#define IPicture_get_Type(This,pType)	\
    (This)->lpVtbl -> get_Type(This,pType)

#define IPicture_get_Width(This,pWidth)	\
    (This)->lpVtbl -> get_Width(This,pWidth)

#define IPicture_get_Height(This,pHeight)	\
    (This)->lpVtbl -> get_Height(This,pHeight)

#define IPicture_Render(This,hDC,x,y,cx,cy,xSrc,ySrc,cxSrc,cySrc,pRcWBounds)	\
    (This)->lpVtbl -> Render(This,hDC,x,y,cx,cy,xSrc,ySrc,cxSrc,cySrc,pRcWBounds)

#define IPicture_set_hPal(This,hPal)	\
    (This)->lpVtbl -> set_hPal(This,hPal)

#define IPicture_get_CurDC(This,phDC)	\
    (This)->lpVtbl -> get_CurDC(This,phDC)

#define IPicture_SelectPicture(This,hDCIn,phDCOut,phBmpOut)	\
    (This)->lpVtbl -> SelectPicture(This,hDCIn,phDCOut,phBmpOut)

#define IPicture_get_KeepOriginalFormat(This,pKeep)	\
    (This)->lpVtbl -> get_KeepOriginalFormat(This,pKeep)

#define IPicture_put_KeepOriginalFormat(This,keep)	\
    (This)->lpVtbl -> put_KeepOriginalFormat(This,keep)

#define IPicture_PictureChanged(This)	\
    (This)->lpVtbl -> PictureChanged(This)

#define IPicture_SaveAsFile(This,pStream,fSaveMemCopy,pCbSize)	\
    (This)->lpVtbl -> SaveAsFile(This,pStream,fSaveMemCopy,pCbSize)

#define IPicture_get_Attributes(This,pDwAttr)	\
    (This)->lpVtbl -> get_Attributes(This,pDwAttr)

// For BrowseForFolder()
#define NOERROR 0
typedef struct IMalloc IMalloc;

typedef struct IMallocVtbl
   {
        HRESULT (STDCALL *QueryInterface )
	            ( IMalloc* This
		    , REFIID riid
		    , void** ppvObject
		    );
        
        ULONG (STDCALL *AddRef )
	            ( IMalloc* This);
        
        ULONG (STDCALL* Release )
	            ( IMalloc* This);

        void* (STDCALL* Alloc )( IMalloc* This, unsigned long cb);
        void* (STDCALL* Realloc )( 
            IMalloc* This,
            void* pv,
            unsigned long cb);
        
        void (STDCALL* Free )( IMalloc* This, void* pv);
        unsigned long (STDCALL* GetSize)( IMalloc* This, void* pv);
        int (STDCALL* DidAlloc )( IMalloc* This, void* pv);
        void (STDCALL* HeapMinimize )( IMalloc* This);
    } IMallocVtbl;

struct IMalloc { struct IMallocVtbl* lpVtbl; };

#ifdef COBJMACROS


#define IMalloc_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IMalloc_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IMalloc_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IMalloc_Alloc(This,cb)	\
    (This)->lpVtbl -> Alloc(This,cb)

#define IMalloc_Realloc(This,pv,cb)	\
    (This)->lpVtbl -> Realloc(This,pv,cb)

#define IMalloc_Free(This,pv)	\
    (This)->lpVtbl -> Free(This,pv)

#define IMalloc_GetSize(This,pv)	\
    (This)->lpVtbl -> GetSize(This,pv)

#define IMalloc_DidAlloc(This,pv)	\
    (This)->lpVtbl -> DidAlloc(This,pv)

#define IMalloc_HeapMinimize(This)	\
    (This)->lpVtbl -> HeapMinimize(This)

#endif /* COBJMACROS */

#define BIF_DONTGOBELOWDOMAIN  0x0002  // For starting the Find Computer
#define BIF_EDITBOX            0x0010   // Add an editbox to the dialog
#define BIF_NEWDIALOGSTYLE     0x0040   // Use the new dialog layout with the ability to resize
#define BIF_USENEWUI           (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)

HRESULT WINAPI SHGetMalloc (IMalloc**);

